package org.acme.jaxws.stubs;

import static org.acme.jaxws.stubs.StatefulStub.*;
import static org.gcube.common.clients.stubs.jaxws.GCoreServiceBuilder.*;

import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.namespace.QName;

import org.gcube.common.clients.stubs.jaxws.GCoreService;

@WebService(name=porttype,targetNamespace=porttypeNS)
public interface StatefulStub {

	public static final String namespace = "http://acme.org/service";
	public static final String localname = "StatefulService";
	public static final QName name = new QName(namespace,localname);
	
	public static final String porttypeNS = "http://acme.org";
	static final String porttype = "StatefulPortType";
	static final String port = "StatefulPortTypePort";
	
	public static String service_class="samples";
	public static String service_name="test-service";
	
	static final GCoreService<StatefulStub> stateful = service().
														 withName(name).
														 coordinates(service_class,service_name).
														 andInterface(StatefulStub.class); 
			
	@WebResult(name="output")
	String calls();
}
