package org.acme.jaxws.stubs;

import static javax.jws.soap.SOAPBinding.ParameterStyle.*;
import static org.acme.jaxws.stubs.StatelessStub.*;
import static org.gcube.common.clients.stubs.jaxws.GCoreServiceBuilder.*;

import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.namespace.QName;
import javax.xml.ws.wsaddressing.W3CEndpointReference;

import org.acme.jaxws.stubs.Types.AnyElement;
import org.acme.jaxws.stubs.Types.Base;
import org.acme.jaxws.stubs.Types.Choice;
import org.acme.jaxws.stubs.Types.MixedWrapper;
import org.acme.jaxws.stubs.Types.PolyWrapped;
import org.acme.jaxws.stubs.Types.Sometype;
import org.gcube.common.clients.stubs.jaxws.GCoreService;

@WebService(name=porttypeLN,targetNamespace=porttypeNS)
@SOAPBinding(parameterStyle=BARE)
@XmlSeeAlso(Sometype.class)
public interface StatelessStub {

	public static final QName name = new QName("http://acme.org/service","StatelessService");
	
	public static final String porttypeNS = "http://acme.org";
	static final String porttypeLN = "StatelessPortType";
	
	public static String service_class="samples";
	public static String service_name="test-service";
	
	static final GCoreService<StatelessStub> stateless = service().
														 withName(name).
														 coordinates(service_class,service_name).
														 andInterface(StatelessStub.class); 
		
	String foo(String s);
	
	@SOAPBinding(parameterStyle=WRAPPED)
	@WebResult(name="anything")
	String fooWrapped(@WebParam(name="param") String s);
	
	MixedWrapper fooMixed(String s);
	
	@SOAPBinding(parameterStyle=WRAPPED)
	@WebResult(name="return")
	String fooBulk(@WebParam(name="param") List<String> elements);
	
	String fooFault(String s) throws FooException;
	
	String baz(VoidWrapper v);

	@SOAPBinding(parameterStyle=WRAPPED)
	void nothing();
	
	BarOutput bar(BarInput s);
	
	@SOAPBinding(parameterStyle=WRAPPED)
	@WebMethod(operationName="bar")
	@WebResult(name="output") 
	List<String> barWrapped(@WebParam(name="in1")String s,@WebParam(name="in2")int i);
	
	W3CEndpointReference create(String s);
	
	String any(Object o);
	
	void anyElement(AnyElement e);
	
	void poly(Base one);
	
	void polyWrapped(PolyWrapped one);
	
	public void choice(Choice c);
	
}
